module cantor1 where

  data Empty : Set where

  data One : Set where
    one : One

  data coprod (A : Set1) (B : Set1) : Set1 where
    inl : ∀ (a : A) -> coprod A B
    inr : ∀ (b : B) -> coprod A B

  postulate exmid : ∀ (A : Set1) -> coprod A (A -> Empty)

  data Eq1 {A : Set1} (x : A) : A -> Set1 where
    refleq1 : Eq1 x x

  data I : (Set -> Set) -> Set where

  data invimageI (a : Set) : Set1 where
    invelmtI : forall x -> (Eq1 (I x) a) -> invimageI a

  cantor : Set -> Set
  cantor a with exmid (invimageI a)
  cantor a | inl (invelmtI x y) = x a -> Empty
  cantor a | inr b = One

  castRL : ∀ { A B } -> Eq1 A B -> B -> A
  castRL refleq1 a = a

  castLR : ∀ { A B } -> Eq1 A B -> A -> B
  castLR refleq1 a = a

  CANTOR : Set
  CANTOR = I cantor

  expand : ∀ a -> Eq1 (cantor (I a)) (a (I a) -> Empty)
  expand a with exmid (invimageI (I a))
  expand a | inl (invelmtI .a refleq1) = refleq1 -- Injectivity is used here
  expand a | inr b with b (invelmtI a refleq1)
  expand a | inr b | ()

  negate : Eq1 (cantor CANTOR) (cantor CANTOR -> Empty)
  negate = expand cantor
  -- Remark: Agda does not accept a direct definition of (expand cantor)

  cantorempty : cantor CANTOR -> Empty
  cantorempty p = castLR negate p p

  Ω : Empty
  Ω = cantorempty (castRL negate cantorempty)
